// rev 04-02-2020
 // rev 23-3-200020
 // Pas assez de ROM RAM sur ce PIC 16F1619
// rev 28/01/2020
// pour 16F1619   @0x78 pour OLED

#define DISPLAY_WIDTH        128
#define DISPLAY_HEIGHT 32

#include "OLED_128x32_Tables_2020_Ultra_Reduite.h"
#include "OLED_128x32_I2C1_remapp_16F1619_2020_04.h"

#define NBPAGES 4
#define OLED_SETCONTRAST 0x81
#define OLED_DISPLAYALLON_RESUME 0xA4
#define OLED_DISPLAYALLON 0xA5
#define OLED_NORMALDISPLAY 0xA6
#define OLED_INVERTDISPLAY 0xA7
#define OLED_DISPLAYOFF 0xAE
#define OLED_DISPLAYON 0xAF
#define OLED_SETDISPLAYOFFSET 0xD3
#define OLED_SETCOMPINS 0xDA
#define OLED_SETVCOMDETECT 0xDB
#define OLED_SETDISPLAYCLOCKDIV 0xD5
#define OLED_SETPRECHARGE 0xD9
#define OLED_SETMULTIPLEX 0xA8
#define OLED_SETLOWCOLUMN 0x00
#define OLED_SETHIGHCOLUMN 0x10
#define OLED_SETSTARTLINE 0x40
#define OLED_MEMORYMODE 0x20
#define OLED_COLUMNADDR 0x21
#define OLED_PAGEADDR   0x22
#define OLED_COMSCANINC 0xC0
#define OLED_COMSCANDEC 0xC8
#define OLED_SEGREMAP 0xA0
#define OLED_CHARGEPUMP 0x8D


#define SSD1306_LCDWIDTH     128
#define  SSD1306_LCDHEIGHT    32

#define SSD1306_MEMORYMODE          0x20 ///< See datasheet
#define SSD1306_COLUMNADDR          0x21 //
#define SSD1306_PAGEADDR            0x22 //
#define SSD1306_SETCONTRAST         0x81 //
#define SSD1306_CHARGEPUMP          0x8D //
#define SSD1306_SEGREMAP            0xA0 //
#define SSD1306_DISPLAYALLON_RESUME 0xA4 //
#define SSD1306_DISPLAYALLON        0xA5 //
#define SSD1306_NORMALDISPLAY       0xA6 //
#define SSD1306_INVERTDISPLAY       0xA7 //
#define SSD1306_SETMULTIPLEX        0xA8 //
#define SSD1306_DISPLAYOFF          0xAE //
#define SSD1306_DISPLAYON           0xAF //
#define SSD1306_COMSCANINC          0xC0 ///
#define SSD1306_COMSCANDEC          0xC8 //
#define SSD1306_SETDISPLAYOFFSET    0xD3 //
#define SSD1306_SETDISPLAYCLOCKDIV  0xD5 //
#define SSD1306_SETPRECHARGE        0xD9 //
#define SSD1306_SETCOMPINS          0xDA //
#define SSD1306_SETVCOMDETECT       0xDB //


extern void UART1_Remappable_Write(unsigned char);
extern void UART1_Write_Remappable_Text(unsigned char *p);
extern void UART1_Write_CText(const char *txt);
extern void CRLF1(void);
//extern void Wait_Keypressed(void);

extern char RamBuffer[];
extern unsigned char CRam1[];

extern sfr SQA;
extern  unsigned char Step;
extern  unsigned char I2C_Retour[];
extern int addr ;  //OLED_ADRESS;



 void WriteCmd(unsigned char I2C_Command)
{ int i;
    I2C_Retour[0]= I2C1_Remappable_Start();
    while(I2C1_Remappable_Is_Idle()==0);
    I2C_Retour[2]=I2C1_Remappable_Wr(addr);
   while(I2C1_Remappable_Is_Idle()==0);
    I2C_Retour[4]=I2C1_Remappable_Wr(0x80);          //send data incomming
   while(I2C1_Remappable_Is_Idle()==0);
   I2C_Retour[5]=I2C1_Remappable_Wr(I2C_Command);       //send command
  while(I2C1_Remappable_Is_Idle()==0);
  I2C1_Remappable_Stop();
  I2C_Retour[6]=255;
}

  void WriteDat(unsigned char Ic)
{
  I2C_Retour[0]= I2C1_Remappable_Start();
   while(I2C1_Remappable_Is_Idle()==0);
  I2C_Retour[1]= I2C1_Remappable_Wr(addr);  //send address
   while(I2C1_Remappable_Is_Idle()==0);
     I2C_Retour[1]= I2C1_Remappable_Wr(0x40);  //send data
   while(I2C1_Remappable_Is_Idle()==0);
  I2C_Retour[3]= I2C1_Remappable_Wr(Ic);       //send Data
   while(I2C1_Remappable_Is_Idle()==0);
    I2C_Retour[4]=255;
   I2C1_Remappable_Stop();
 }


 // Used when doing Horizontal or Vertical Addressing
void setColAddress()
{
  WriteCmd(SSD1306_COLUMNADDR); // 0x21 COMMAND
  WriteCmd(0); // Column start address
  WriteCmd(SSD1306_LCDWIDTH-1); // Column end address
}

void setPageAddress()
{
  WriteCmd(SSD1306_PAGEADDR); // 0x22 COMMAND
  WriteCmd(0); // Start Page address
  WriteCmd((SSD1306_LCDHEIGHT/8)-1);// End Page address
}


void OLED_Init(void)
{
//voir SSD1306.pdf
//Software Configuration

       WriteCmd(0xAE); //display off
       Delay_ms(20);    // was 200
       WriteCmd(0xAF); //display on
       Delay_ms(20);     // was 200
       WriteCmd(0xB0);// Set GDDRAM Page start adresse [2:0]  0  7
       WriteCmd(0x00);   // mini 0
       WriteCmd(0x03);   // maxi
       //  WriteCmd(0x07);   // maxi  pour 128x64
       WriteCmd(0x20); //Set Horizontal Memory Addressing Mode
                       //A[1:0] = 00b, Horizontal Addressing Mode
                       //A[1:0] = 01b, Vertical Addressing Mode
                       //A[1:0] = 10b, Page Addressing Mode (RESET)
                       //A[1:0] = 11b, Invalid
        WriteCmd(0x02); //    Page Addressing Mode (RESET)
        WriteCmd(0x21); // Setup column start and end address
        WriteCmd(0);   //A[6:0] : Column start address, range : 0-127d,(RESET=0d)
        WriteCmd(0x7F);  // B[6:0]: Column end address, range : 0-127d,(RESET =127d)
        WriteCmd(0x22);//  Setup page start and end address
                         //  A[2:0] : Page start Address, range : 0-7d,
                         // (RESET = 0d)
                         //  B[2:0] : Page end Address, range : 0-7d,
                         // (RESET = 7d)
        WriteCmd(0x00);
        WriteCmd(0x03);     //was 0x07
       // WriteCmd(0xA0); //--set segment re-map colum 0 to SEG 0     de droite -> gauche
       WriteCmd(0xA1); //--set segment re-map to 127     de gauche -> droite
       WriteCmd(0xA4);//command enable display outputs according to the GDDRAM contents.
       //  WriteCmd(0xA5);//command forces the entire display to be ON, regardless of the contents of the display data RAM.
       WriteCmd(0xA6);//normal display
       //  WriteCmd(0xA7);//reverse display
       WriteCmd(0xC8); //Set COM Output Scan Direction
       //C0h, X[3]=0b: normal mode (RESET) Scan from COM0 to COM[N 1]
       //C8h, X[3]=1b: remapped mode. Scan from COM[N-1] to COM0
       WriteCmd(0xD3); //--set start line address 40h =  set   to 0
       WriteCmd(0x40);  // ou 0x3F
       // was     WriteCmd(0x00);
       //0xD3,0x3F, // DISPLAY offset ROW0 - L0xD3,0x00,leaves one row of pixels at top. 0xD3,0x3F is better
       WriteCmd(0xD5); //--set display clock divide ratio/oscillator frequency
       WriteCmd(0x80); //--set divide ratio   80h
       WriteCmd(0xA8); //--set multiplex ratio to 63
       WriteCmd(0x3F); //  was 3F
       WriteCmd(0xD6); //-- This command is to set the vcommon signals padconfiguration.
       WriteCmd(0x80); // --set divide ratio   80h
       WriteCmd(0xD9); //--set display clock divide ratio/oscillator frequency
        // A[3:0] : Phase 1 period of up to 15 DCLK clocks 0 is invalid entry(RESET=2h)
        // A[7:4] : Phase 2 period of up to 15 DCLKclocks 0 is invalid entry(RESET=2h )
       WriteCmd(0x1F); //  22h --reset values   22h
       //  WriteCmd(0x1F); //  44h --reset values   22h
       //0xDA, (C.OLED_HEIGHT==64)?0x12:0x02,
       WriteCmd(0xDA); //--set com pins hardware configuration
       WriteCmd(0x20);  // was 0x02      32
       // WriteCmd(0x00);  // was 0x02      32
       //        WriteCmd(0x12);  // 0x12h   64
       //        A[4]=0b, Sequential COM pin configuration
       //        A[4]=1b(RESET), Alternative COM pin configuration
       //        A[5]=0b(RESET), Disable COM Left/Right remap
       //        A[5]=1b, Enable COM Left/Right remap
       //   WriteCmd(0xE0);      // Read-Modify-Write start
       WriteCmd(0xEE);      // Read-Modify-Write end.
       WriteCmd(0x81); //--set contrast control register
       WriteCmd(0x7F); // 0x00~0xff
       WriteCmd(0x2E); // no scrolling
       WriteCmd(0xDB); //--set VComH deselect level
       //   WriteCmd(0x35); //--POR =35h
       WriteCmd(0x40); // 20H => 0.77x Vcc (Reset value)
       WriteCmd(0x8D); //--set DC-DC enable  Charge Pump Setting
       WriteCmd(0x14); // 0x14 Enable Charge Pump
       WriteCmd(0xAF); //--turn on oled panel
}



void OLED_SetPos(unsigned char x, unsigned char y)
{ 
       WriteCmd(0xB0+y);
       WriteCmd(x&0x0f) ;
       WriteCmd(((x&0xf0)>>4)|0x10);

}

void Write_Char_At(unsigned char X,unsigned char Y, unsigned char C)
{ int i;
unsigned char ca;
/*
      OLED_SetPos(X,Y);
     if (C==176)     // caractere  (degrC)  dplac en codage 124 (124-32=92)
      {
      for(i=0;i<6;i++)   WriteDat(font_regular_6x8[92][i]) ;
      }
      else
      {
        if (C>=32)
        {
         ca=C-32;
         for(i=0;i<6;i++)   WriteDat(font_regular_6x8[ca][i]) ;
       }
     }
     */
}

void OLED_Fill(unsigned char fill_Data)
{
        unsigned char m,n;
        OLED_SetPos(0,0);
        for(m=0;m<4;m++)   // was <8
        {
                WriteCmd(0xB0+m);                //page0-page1
                Delay_us(50);
                WriteCmd(0x00);                //low column start address
                WriteCmd(0x10);                //high column start address
                for(n=0;n<128;n++)
               {
                    WriteDat(fill_Data);
                    Delay_us(50);
                }
        }
}

void OLED_CLS(void)
{
     unsigned char m,n;
      WriteCmd(0x21); // Setup column start and end address
      WriteCmd(0);   //A[6:0] : Column start address, range : 0-127d,(RESET=0d)
      WriteCmd(127);  // B[6:0]: Column end address, range : 0-127d,(RESET =127d)
      WriteCmd(0x22);
      WriteCmd(0);
      WriteCmd(3);   // was 7
      WriteCmd(0xD3); //-set display offset
      WriteCmd(0x40); //page 0  3
      OLED_SetPos(0,0);
        for(m=0;m<4;m++)  // was <8
        {
                WriteCmd(0xB0+m);                //page0-page1
                WriteCmd(0x01);                //low column start address
                WriteCmd(0x10);                //high column start address
                 Delay_us(10);
                for(n=0;n<128;n++)
               {
                    WriteDat(0x00);
                     Delay_us(20);
                }
        }
        WriteCmd(0x2E);
        OLED_SetPos(0,0);
}

void OLED_ON(void)
{
       WriteCmd(0x8D);
       WriteCmd(0x14);
       WriteCmd(0xAF);
}

void OLED_OFF(void)
{
        WriteCmd(0x8D);
        WriteCmd(0x10);
        WriteCmd(0xAE);
}

//--------------------------------------------------------------
// Prototype      : void OLED_ShowChar(unsigned char x, unsigned char y, unsigned char ch[], unsigned char TextSize)
// Parameters     : x,y --(x:0~127, y:0~7); ch[] ; TextSize (1:6*8 ; 2:8*16)
//--------------------------------------------------------------
void OLED_ShowStr(unsigned char x, unsigned char y, unsigned char *ch, unsigned char TextSize)
{
        unsigned char c = 0,i = 0,j = 0;
        unsigned char xd=0,yd=0;
        int kx,lx;
        xd=x;
        yd=y;
        OLED_SetPos(xd,yd);
        switch(TextSize)
        {
                case 1:
                  /*
                  while((*(ch+j) !=0) && ( yd<5))
                    {
                     c = *(ch+j) ;
                     if (c >96)  c=c -64;  else c=c-32;
                     if(xd > 120)
                     {
                      xd = 0;
                      yd++;
                       OLED_SetPos(xd,yd);
                     }
                      for(i=0;i<6;i++)   WriteDat(font_regular_6x8[c][i]) ;
                     xd=xd+6;
                     j++;
                    }
                    */
                    break;
                case 2:

                   /*  kx=strlen(ch);
                     j=0;
                     while((*(ch+j) !=0) && (j<16) )
                     {
                      c = *(ch+j);
                       if (c >96)  c=c -64;  else c=c-32;
                    //  if(xd > 112)         // width > 15 chars x8
                    //  {
                    //    xd = 0;      // si deborde la ligne
                    //    yd=yd+1;     // change de ligne
                    //   }
                      OLED_SetPos(xd,yd);
                     for(i=0;i<8;i++) WriteDat(F8X16[c*16+i]);
                     OLED_SetPos(xd,yd+1);
                     for(i=0;i<8;i++) WriteDat(F8X16[c*16+i+8]);
                      xd=xd+8;
                      j++;
                     }
                     */
                      break;
                 case 3:
                 lx=strlen(ch);
                  if (lx>0)
                   {
                     for (i=0;i<lx;i++)
                     {
                     //cadrage  droite
                      kx=(i+7-lx) *16;
                      c=*(ch+i);
                      if ((c>47) && (c<58))
                       Big_affichage(kx,c-48);
                       else
                        {
                         switch (c)
                         {
                          case 46 :
                            Big_affichage(kx,10) ;     //point
                            break;
                          case 32:
                             Big_affichage(kx,11) ;   // space=Blanc
                             break;
                         case 176:
                             Big_affichage(kx,12) ;   //  ( degr)
                             break;
                          default:
                             Big_affichage(kx,11) ;   //space
                            break;
                         }
                       }
                     }
                   }
                    break;
                 default:
                    break  ;
        }
}



void OLED_Goto_Char_xy(char x, char y){
    if( x > 21 || y > 3) return;// out of display
    x = x * 8;  // one char: 8 pixel width
   //  actualIndex = (x)+(y*DISPLAY_WIDTH);
    I2C1_Remappable_Start();                // start i2c communication
     while( I2C1_Remappable_Is_Idle()==0);
    I2C1_Remappable_Wr(0x00);        // 0x00 for command, 0x40 for data
     while( I2C1_Remappable_Is_Idle()==0);
    I2C1_Remappable_Wr(0xB0 + y);// set page start to y
     while( I2C1_Remappable_Is_Idle()==0);
    I2C1_Remappable_Wr(0x21);        // set column start
     while( I2C1_Remappable_Is_Idle()==0);
    I2C1_Remappable_Wr(x);                // to x
     while( I2C1_Remappable_Is_Idle()==0);
    I2C1_Remappable_Wr(0x7f);        // set column end to 127
     while( I2C1_Remappable_Is_Idle()==0);
    I2C1_Remappable_Stop();                // stop i2c communication
     while( I2C1_Remappable_Is_Idle()==0);

}



// Prints a display big number (16x16 bytes) in coordinates X Y,
// being multiples of 16 , This means we have 16 COLS (0-15)
// pas assez de ROM pour 16F1619

/*
  void ShowBigNumber(unsigned char x,unsigned char  y, unsigned char N)  //16x16
  {
    unsigned char x1,v=0;
    unsigned int  adder;
    unsigned char Cc;
     adder=32*N;
      OLED_SetPos(x , y);
      for(v = 0;v < 16;v=v+2)
        {
         Cc=Big_Numbers[adder];
         WriteDat(Cc);
          adder++;
        }
         adder=32*N;
         OLED_SetPos(x , y+1);
        for(v = 1;v < 16;v=v+2)
        {
         Cc=Big_Numbers[adder];
         WriteDat(Cc);
          adder++;
        }
  }
*/

void Big_affichage( unsigned char posX, unsigned char N )
{   int k;
    WriteCmd(0x20);WriteCmd(0x00); // horizontal mode
    WriteCmd(0x21); // On configre la largeur de l'ecran
    // pour forcer, limiter le retournement horizontal   voir DS figure 10.5
    WriteCmd(0+posX);        // Colonne minimum
    WriteCmd(15+posX);        // Colonne MAximum;
    WriteCmd(0x22);
    // positionement vertical entre page 1 et 3    H=16 pixels
    WriteCmd(1);
    WriteCmd(3);
   for(k=0;k<48;k++) WriteDat(*(Big_Numbers[N]+k));
  }



 /*
void Affiche_Car_8x8 ( unsigned char posX, unsigned char PosY,unsigned char N )
 {   int k;
    WriteCmd(0x20);WriteCmd(0x00); // horizontal mode
    WriteCmd(0x21); // On configre la largeur de l'ecran
    // pour forcer, limiter le retournement horizontal   voir DS figure 10.5
    WriteCmd(0+posX);        // Colonne minimum
    WriteCmd(7+posX);        // Colonne MAximum;
    WriteCmd(0x22);
    // positionement vertical entre page 1 et 3    H=16 pixels
    WriteCmd(PosY);
    WriteCmd(PosY+1);
    for(k=0;k<7;k++) WriteDat(*(Car_Speciaux[N]+k));
  }
 

  
void OLED_Draw_Pixel(unsigned char x, unsigned char y,unsigned char Color)
{  int  m;
   unsigned char y1, n;
    y1=y;
        if( x > 127 || y > 31) return; // out of Display
        n=  1 << (y1 % 8);
       m= y1/8 ;
       m= m<<7 ;
       m=m+x;
        if( Color ==1) {
        RamBuffer[m] =    RamBuffer[m] | n ;
        }
         else
         {
         RamBuffer[m] =  RamBuffer[m] &  (~n) ;
          }
}


void Draw_Pixel(unsigned char x, unsigned char y,unsigned char Color)
{  int  m, nt,page,b1;
    page=y/8;
    b1=y-(page*8);
    m=page*128+x;
    nt= RamBuffer[m];
    if (Color==1)
    nt=nt | (1<<b1);
    else
     nt=nt & (~(1<<b1));
     RamBuffer[m]=nt ;

}
   */

 
 void RAZ_RamBuffer(void)
 {      unsigned int m   ;
        for(m=0;m<512;m++)
        {
          RamBuffer[m]=0;
         }
 }

 void Refresh_OLED(void)
 {
      unsigned int m,x,k;
      OLED_SetPos(0,0);
        for(m=0;m<4;m++)  // was <8
        {
       //  WriteCmd(0xB0+m);                //page0-page1
         Delay_us(100);
         for (x=0;x<128;x++)
         {
          k=(m*128)+x ;
          WriteDat(RamBuffer[k]);
          Delay_us(20);
         }
        }
        OLED_SetPos(0,0);
 }